--  AW new jog functions with individual selection buttons
--	29/3/2018	Moved from screen load script to this module

local Jogging = {}

--AW Set jog mode to incremental
function Jogging.SetJogModeInc(dist)
    local inst = mc.mcGetInstance()
    local rc = mc.mcProfileWriteString(inst,'Preferences', 'JogInc', dist)
    local rc = mc.mcProfileWriteString(inst,'Preferences', 'JogDist', dist)
    rc = mc.mcProfileWriteInt(inst,'Preferences', 'JogType', mc.MC_JOG_TYPE_INC)
    dist = tonumber(dist)
    local axis = 0
    while (axis <= 5) do
        if (dist < 0) or (dist == nil) then
            dist = 0
        end
        --rc = mc.mcJogSetInc(inst, axis, dist)
        --rc = mc.mcJogSetType(inst, axis, mc.MC_JOG_TYPE_INC)
        axis = axis + 1
    end
    local rc = mc.mcProfileSave(inst)
end


--AW Set jogmode to continuous
---------------------------------------------------------------
function Jogging.SetJogModeCont()
    local inst = mc.mcGetInstance()
    local rc = mc.mcProfileWriteInt(inst,'Preferences', 'JogType', mc.MC_JOG_TYPE_VEL)
    local axis = 0
    while (axis <= 5) do
        --rc = mc.mcJogSetType(inst, axis, mc.MC_JOG_TYPE_VEL)
        axis = axis + 1
    end
    local rc = mc.mcProfileSave(inst)
end


--AW Toggle Continuous jog via screen button Cont.
--Set currently selected Jog increment button to 
--Cyan for Cont and Green for Inc jog
function Jogging.ToggleJogCont()
    local button = 1
    local ltBlue = "#00A0FF" -- Define light blu
    local ltGrey = "#C0C0C0" -- Define light grey
    while scr.IsControl(string.format("btnJogInc%.0f", button)) do
        local clr = scr.GetProperty(string.format("btnJogInc%.0f", button), 'Bg Color')--Retrieve colour Grey
        if (clr == "Green") then  
            -- change jog mode to Cont
            scr.SetProperty(string.format("btnJogInc%.0f", button), 'Bg Color', ltBlue)
            scr.SetProperty('btnJogCont', 'Bg Color', ltBlue) 
            Jogging.SetJogModeCont()
        elseif (clr == ltBlue) then  
            -- change jog mode to Inc
            Jogging.SelectJogInc(button)
        else
            -- shouldn't get here
            scr.SetProperty(string.format("btnJogInc%.0f", button), 'Bg Color', ltGrey)
        end
        button = button + 1
    end
end

--AW Select jog increment via screen buttons
function Jogging. SelectJogInc(btn)
    local rc, buff
    local ltGrey = "#C0C0C0" -- Define light grey
    local  inst = mc.mcGetInstance()
    local button = 1
    while scr.IsControl(string.format("btnJogInc%.0f", button)) do
        if (button == btn) then
            scr.SetProperty(string.format("btnJogInc%.0f", button), "Bg Color", 'Green')
            buff, rc = scr.GetProperty(string.format("btnJogInc%.0f", button), "Label")
            Jogging.SetJogModeInc(buff)
        else
           scr.SetProperty(string.format("btnJogInc%.0f", button), 'Bg Color', ltGrey)
        end
        button = button + 1
    end
    scr.SetProperty('btnJogCont', 'Bg Color', ltGrey)
end


--AW Initialise jog button labels and activate button
function Jogging.InitialiseJogBtns()
    local rc, buff, prevJogInc, prevJogType
    local  inst = mc.mcGetInstance()
    buff, rc = mc.mcProfileGetString(inst,'Preferences', "JogDist", '0')
    prevJogInc, rc = tonumber(buff) -- previous saved value
    prevJogType = mc.mcProfileGetInt(inst,'Preferences', 'JogType', mc.MC_JOG_TYPE_INC)

    local activeBtn = 0
    local button = 1
    while scr.IsControl(string.format("btnJogInc%.0f", button)) do
        --set button label from profile
        buff, rc = mc.mcProfileGetString(inst,'Preferences', string.format("JogInc%.0f", button), '-')
        if (rc ~= mc.MERROR_NOERROR) then; break; end
        scr.SetProperty(string.format("btnJogInc%.0f", button), 'Label', buff)
        --Check if this is the active button
        if (tonumber(buff) == prevJogInc) then
            activeBtn = button
        end
        button = button + 1
    end

    --restore previous incremental jog distance
    if (activeBtn > 0) then
        Jogging.SelectJogInc(activeBtn)
    end
    -- restore previous jog mode
    if (prevJogType == mc.MC_JOG_TYPE_VEL) or (activeBtn == 0)then
        Jogging.ToggleJogCont()
    end
end


--AW Jog button down initiates motion.
--Takes type and distance from profile
function Jogging.JogBtnDown(axis, direction, type)
    local inst = mc.mcGetInstance()
    if (type == nil) then
        type = mc.mcProfileGetInt(inst,'Preferences', 'JogType', mc.MC_JOG_TYPE_INC)
    end
     --rc = mc.mcJogSetType(inst, axis, type)
    local dist, rc = mc.mcProfileGetString(inst,'Preferences', "JogDist", '0')
    dist = tonumber(dist)
    local defUnits = mc.mcCntlGetUnitsDefault(inst)
    rc = mc.mcJogSetUnitsMode(inst, axis, defUnits)
    if (type == mc.MC_JOG_TYPE_INC) then
        if (direction == mc.MC_JOG_NEG) then
            dist = -1 * dist
        end
        --local rc = mc.mcJogSetInc(inst, axis, dist)
        rc = mc.mcJogIncStart(inst, axis, dist)
    elseif (type ==mc.MC_JOG_TYPE_VEL) then
        rc = mc.mcJogVelocityStart(inst, axis, direction)
    end
end

--AW Jog button Up should stop motion
--Takes type and distance from profile.
function Jogging.JogBtnUp(axis, direction, type)
    local inst = mc.mcGetInstance()
    if (type == nil) then
        type = mc.mcProfileGetInt(inst,'Preferences', 'JogType', mc.MC_JOG_TYPE_VEL)
    end
    local dist, rc = mc.mcProfileGetString(inst,'Preferences', "JogDist", '0')
    dist = tonumber(dist)
    
    if (type == mc.MC_JOG_TYPE_INC) then
        if (direction == mc.MC_JOG_NEG) then
            dist = -1 * dist
        end
        --rc = mc.mcJogIncStop(inst, axis, dist) --AW doesn't honour distance
    elseif (type ==mc.MC_JOG_TYPE_VEL) then
        rc = mc.mcJogVelocityStop(inst, axis)
    end
end

return Jogging

